/*
 * Licensed Materials - Property of IBM
 * 5725-G92 (C) Copyright IBM Corp. 2006, 2012. All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

//
//  MyAppDelegate.m
//  module451ContainerForServerPages
//
//

#import "module451ContainerForServerPages.h"


@implementation MyAppDelegate

- (id) init
{	
	/*
	* If you need to do any extra app-specific initialization, you can do it here.
	**/
    return [super init];
}

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    BOOL ret = [super application:application didFinishLaunchingWithOptions:launchOptions];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(didFinishWLNativeInit:) name:@"didFinishWLNativeInit" object:nil];
    
    return ret;
}

// Use this function to refer to webview
/**
 * This is main kick off after the app inits, the views and Settings are setup here.
 */
-(void) didFinishWLNativeInit:(NSNotification *)notification {
    
    NSString* remoteURLStr = @"http://m.ibm.com";
    NSURL* remoteURL = [NSURL URLWithString: remoteURLStr];
    NSURLRequest* request = [NSURLRequest requestWithURL:remoteURL];
    [self.viewController.webView loadRequest:request];

    /*
     * If you need to do any extra app-specific initialization, you can do it here.
     * Note: At this point webview is available.
     **/
}


/**
* These functions handle moving to background and foreground and invoke the appropriate JavaScript functions in the UIWebView.
*/

- (void)applicationDidEnterBackground:(UIApplication *)application
{
	NSString *result = [super.viewController.webView stringByEvaluatingJavaScriptFromString:@"WL.App.BackgroundHandler.onAppEnteringBackground();"]; 
	if([result isEqualToString:@"hideView"]){
		[[self.viewController view] setHidden:YES];
	}
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
	NSString *result = [super.viewController.webView stringByEvaluatingJavaScriptFromString:@"WL.App.BackgroundHandler.onAppEnteringForeground();"];
	if([result isEqualToString:@"hideViewToForeground"]){
		[[self.viewController view] setHidden:NO];
	}
}

- (void)applicationDidBecomeActive:(UIApplication *)application 
{
	[super applicationDidBecomeActive:application];
    /*
     * If you need to do any extra app-specific stuff, you can do it here.
     **/
}

- (void)dealloc
{
	[ super dealloc ];
}

@end
